unit RtRegw32;

interface

uses
   Windows;

type
  TSaveKind = (skNone,skDef,skIni,skDll);
  TGenKind = (gkSingle,gkDouble);

procedure RTSetPCLock(Value: BOOL); stdcall;

function RTRegister(ProductKey,UserKey,RegKey: PChar): BOOL; stdcall;
function RTRegisterByFile(ProductKey,FileName: PChar): BOOL; stdcall;

function RTGetUserKey(ProductKey,Value: PChar): BOOL; stdcall;
function RTSetUserInfo(ProductKey,Info,Value: PChar): BOOL; stdcall;
function RTGetUserInfo(ProductKey,Info,Value: PChar): BOOL; stdcall;
function RTDelUserInfo(ProductKey,Info: PChar): BOOL; stdcall;

function RTIsReg(ProductKey: PChar): Bool; stdcall;
function RTDelReg(ProductKey: PChar): Bool; stdcall;
function RTCheckReg(ProductKey: PChar): longint; stdcall;

function RTIsCountLock(ProductKey: PChar): BOOL; stdcall;
function RTSetCountLock(ProductKey: PChar; Value: longint): BOOL; stdcall;
function RTDelCountLock(ProductKey: PChar): BOOL; stdcall;
function RTCheckCountLock(ProductKey: PChar): longint; stdcall;

function RTIsDateLock(ProductKey: PChar): BOOL; stdcall;
function RTSetDateLock(ProductKey: PChar; Value: longint): BOOL; stdcall;
function RTDelDateLock(ProductKey: PChar): BOOL; stdcall;
function RTCheckDateLock(ProductKey: PChar): longint; stdcall;

function RTGetVersion: longint; stdcall;
function RTGetGenKind: TGenKind; stdcall;
function RTSetGenKind(Value: TGenKind): BOOL; stdcall;
procedure RTSetEncodeKey(Value: PChar); stdcall;

function RTGetSaveKind: TSaveKind; stdcall;
function RTSetSaveKind(Value: TSaveKind): BOOL; stdcall;
procedure RTGetSaveFile(Value: PChar); stdcall;
function RTSetSaveFile(Value: PChar): BOOL; stdcall;

function RTGetSafeKind: TSaveKind; stdcall;
function RTSetSafeKind(Value: TSaveKind): BOOL; stdcall;
procedure RTGetSafeFile(Value: PChar); stdcall;
function RTSetSafeFile(Value: PChar): BOOL; stdcall;

implementation

procedure RTSetPCLock;     external 'RTREGW32';

function RTRegister;       external 'RTREGW32';
function RTRegisterByFile; external 'RTREGW32';

function RTGetUserKey;		external 'RTREGW32';
function RTSetUserInfo;		external 'RTREGW32';
function RTGetUserInfo;		external 'RTREGW32';
function RTDelUserInfo;		external 'RTREGW32';

function RTIsReg;          external 'RTREGW32';
function RTDelReg;         external 'RTREGW32';
function RTCheckReg;       external 'RTREGW32';

function RTIsCountLock;    external 'RTREGW32';
function RTSetCountLock;   external 'RTREGW32';
function RTDelCountLock;   external 'RTREGW32';
function RTCheckCountLock; external 'RTREGW32';

function RTIsDateLock;     external 'RTREGW32';
function RTSetDateLock;    external 'RTREGW32';
function RTDelDateLock;    external 'RTREGW32';
function RTCheckDateLock;  external 'RTREGW32';

function RTGetVersion;     external 'RTREGW32';
function RTGetGenKind;		external 'RTREGW32';
function RTSetGenKind;		external 'RTREGW32';
procedure RTSetEncodeKey;  external 'RTREGW32';

function RTGetSaveKind;    external 'RTREGW32';
function RTSetSaveKind;    external 'RTREGW32';
procedure RTGetSaveFile;	external 'RTREGW32';
function RTSetSaveFile;		external 'RTREGW32';
function RTGetSafeKind;    external 'RTREGW32';
function RTSetSafeKind;    external 'RTREGW32';
function RTSetSafeFile;		external 'RTREGW32';
procedure RTGetSafeFile;	external 'RTREGW32';

end.

